function [propensity] = membrane_test_a_protein(trainedSOM, proteinCode, W,delta,dataBase)

% obtained SOM parameters
w = size(trainedSOM.sM.labels,1); % total num of som nodes
w_0 = 0;
w_1 = 0;

index_0 = ones(w,1);
index_1 = zeros(w,1);

for i = 1 : w
    if trainedSOM.sM.labels{i} == '0'
        w_0 = w_0 + 1;
        index_0(i,1) = 0;
    elseif trainedSOM.sM.labels{i} == '1'
        w_1 = w_1 + 1;
        index_1(i,1) = 1;
    end
end

a = find(index_0 == 0);
b = find(index_1 == 1);

m_0 = trainedSOM.sM.codebook(a,:);
m_1 = trainedSOM.sM.codebook(b,:);

p_0_prior  = w_0 / (w_0 + w_1) ;
p_1_prior  = w_1 / (w_0 + w_1) ;



%load tesing pssm
test_pssm =  load (strcat(dataBase,'\totalPSSMs\',proteinCode,'.mat'),'-ascii');
seqLen = size(test_pssm,1);  % length of the protein
propensity = zeros(seqLen,1);

propensity_filtered = zeros(seqLen,1);

interval = (W - 1) / 2 ; 
beginIndex = interval +1 ;
endIndex = seqLen - interval;

 for  i = 1 :  seqLen  % predict each animo acid inturn
   if  i < beginIndex
        flm = zeros(W,20);
        flm(W-(i+interval) +1:W,:) = test_pssm(1:i+interval,:);
        for r = 1: W-(i+interval)
            for c = 1: 20
                flm(r,c) = NaN;
            end
        end        
        flm = flm';
        flm = reshape(flm,1,size(flm,1)*size(flm,2)); % 1* N format
        bmu = som_bmus(trainedSOM.sM, flm);
        x = trainedSOM.sM.codebook(bmu,:);        
   elseif i > endIndex
       flm = zeros(W,20);
       flm(1:seqLen - (i-interval) +1 ,:) = test_pssm(i-interval:seqLen,:);
        for r = seqLen - (i-interval) +1 + 1: W
            for c = 1: 20
                flm(r,c) = NaN;
            end
        end   
        flm = flm';
        flm = reshape(flm,1,size(flm,1)*size(flm,2)); % 1* N format
        bmu = som_bmus(trainedSOM.sM, flm);
        x = trainedSOM.sM.codebook(bmu,:);
   else
       %
        flm = test_pssm(  i - interval : i + interval, :);   % get FLM of residue i   
        flm = flm';
        flm = reshape(flm,1,size(flm,1)*size(flm,2)); % 1* N format
        x = flm;
   end
   
   %predict x to be 1 or 0
   [p_0,p_1] = membrane_predict_a_residue(x,m_0,m_1,p_0_prior,p_1_prior,delta);   
   propensity(i,1) = p_1;
   
 end

%filter

%[filtered_1, filtered_2, helix] = membrane_filter(propensity,1,8);
%helix = [proteinCode , helix];
