%Input:  file name of train patterns
%Usage.  [trainedSOM] = membrane_train('data\protein_train_patterns.mat') 
%Note that the format of the input file is ASCII

function [trainedSOM] = membrane_train(W,dataBase)

fprintf('Load Training Vectors\n');
if W == 13
    train_0 =load (strcat(dataBase,'\current\train_13_0.mat'),'-ascii');
    train_1 =load (strcat(dataBase,'\current\train_13_1.mat'),'-ascii');    
end

if W == 15
    train_0 =load (strcat(dataBase,'\current\train_15_0.mat'),'-ascii');
    train_1 =load (strcat(dataBase,'\current\train_15_1.mat'),'-ascii');    
end

num_0 = size(train_0,1);
num_1 = size(train_1,1);


label_0 = cell(num_0,1);
for i = 1 : num_0
    label_0{i,1} = '0';
end
label_1 = cell(num_1,1);
for i = 1 : num_1
    label_1{i,1} = '1';
end;


label_samples = [label_0;label_1];


train_samples = [train_0; train_1];


% 
fprintf('Build and Train SOM\n');
sD = som_data_struct(train_samples,'labels',label_samples);

%sM = som_make(sD, 'algorithm','seq','training', [10 10],'lattice', 'rect');    
%sM = som_make(sD, 'algorithm','batch','training',[10 10],'lattice', 'rect');
sM = som_make(sD,'algorithm','batch','training',[10 10]); 
sM = som_autolabel(sM,sD,'vote');
som_show(sM,'empty','Labels');
som_show_add('label',sM);

 
fprintf('Save the Trained SOM\n');
trainedSOM.sM = sM;   %SOM
trainedSOM.train_samples = train_samples;   
save(strcat(dataBase,'\current\trainedSOM',num2str(W)), 'trainedSOM');


%display an empty grid
%som_show(sM,'empty','Labels')

%show test data
%som_show_add('hit',som_hits(trainedSOM.sM,trainedSOM.train_patterns(3,:)));
%[bmu err] = som_bmus(trainedSOM.sM, trainedSOM.train_patterns(3, :));




