import java.util.HashMap;
import java.util.Random;
import java.util.Set;
import edu.njust.cs.bio.util.FASTAFileParser;
import edu.njust.cs.util.FileObject;
public class GenerateFiveFoldSamples {
	public static void main(String[] args) {
		
		if (args.length != 4){
			System.out.println("Usage:   java GenerateFiveFoldSamples   path fileName  totalSampleNum num-fold");
			System.out.println("e.g.:   java GenerateFiveFoldSamples d:\\db117  db117_total_proteins.fasta  117  5");
			System.exit(-1);
		}
		String path = args[0];
		String fileName = args[1] ;
		int totalSampleNum = Integer.parseInt(args[2]);
		int num_fold =  Integer.parseInt(args[3]);
		
		HashMap<String, String> proteinSeqs = FASTAFileParser
				.parseProteinSeqs(path + "\\" + fileName);

		Set<String> keys = proteinSeqs.keySet();
		Object[] keysArray = keys.toArray();
		int num = keysArray.length;
		
		//randomly arrange the total samples
		Random r = new Random();
		for(int i = 0; i < 10000; i ++){
			int a = r.nextInt(num);
			int b = r.nextInt(num);
			String temp =(String) keysArray[a];
			keysArray[a] = keysArray[b];
			keysArray[b] = temp;
		}		
	    // generate five-fold training and testing samples  
		int testingNum = (int)Math.ceil((double)(totalSampleNum)/(double)(num_fold));
		boolean [] flags = new boolean[totalSampleNum];
		for(int i =0; i < num_fold; i ++){
			for(int j = 0 ; j < flags.length; j ++){
				if( i*testingNum <= j && j < (i+1)*testingNum){
					flags[j] = true;
				}
				else{
					flags[j] = false;
				}
			}			
			StringBuffer testingBuf = new StringBuffer();
			StringBuffer trainingBuf = new StringBuffer();
			for(int j = 0 ; j < flags.length; j ++){
				if(flags[j] == true){  //testing samples
					testingBuf.append(">" + keysArray[j] +"\n");
					testingBuf.append(proteinSeqs.get( keysArray[j]));
					testingBuf.append("\n");
				}else{ //training samples
					trainingBuf.append(">" + keysArray[j] +"\n");
					trainingBuf.append(proteinSeqs.get( keysArray[j]));
					trainingBuf.append("\n");
				}			
			}
			
			String str_testing = testingBuf.toString();
			str_testing = str_testing.substring(0, str_testing.length()-1);
			
			String str_training = trainingBuf.toString();
			str_training = str_training.substring(0, str_training.length() -1);
			
			FileObject fo = new FileObject();
			fo.setContents(str_testing.getBytes());
			fo.writeToFile(path+"//fold" + (i+1), "testingProtein.fasta");
			
			fo.setContents(str_training.getBytes());
			fo.writeToFile(path+"//fold" + (i+1), "trainingProtein.fasta");
		}
	}
}
