import java.util.HashMap;
import java.util.Set;
import edu.njust.cs.bio.protein.PSSM;
import edu.njust.cs.bio.util.FASTAFileParser;
import edu.njust.cs.bio.util.ProteinSeqAnalysis;
import edu.njust.cs.util.AarrayUtil;
import edu.njust.cs.util.FileObject;
public class GenerateTrainingVectors {
	private static String dataBasePath = "./db126";
	
	public static void main(String []args){
		if (args.length != 1){
			System.out.println("Usage:   java GenerateTrainingVectors dataBasePath");
			System.out.println("e.g.:   java  -Xmn128m -Xms256m -Xmx512m GenerateTrainingVectors ../db126");
			System.out.println("e.g.:   java  -Xmn128m -Xms256m -Xmx512m GenerateTrainingVectors ../db120");
			System.exit(-1);
		}		
		dataBasePath = args[0];
		
		generate(13);
		generate(15);
		
	}	
	private static void generate(int windowSize) {
		// 1 .
		StringBuffer buf_1 = new StringBuffer();
		StringBuffer buf_0 = new StringBuffer();
		
		// 2.	
		String source = dataBasePath + "/current/trainingProtein.fasta";
	
		HashMap<String, String> proteinSeqs = FASTAFileParser
				.parseProteinSeqs(source);
		Set<String> keys = proteinSeqs.keySet();
		Object[] keysArray = keys.toArray();
		for (int i = 0; i < keysArray.length; i++) {
			String proteinCode = (String) keysArray[i];
			int k = proteinCode.indexOf(" ");
			String proteinCodeShort = proteinCode.substring(0, k);
			System.out.println("Processing " + proteinCodeShort + "...");
			String fileName = dataBasePath + "/totalPSSMs/" + proteinCodeShort + ".mat";
			double [][]pssm = PSSM.readMatrix(fileName);
			
			int seqLen = pssm.length; // г
			int interval = (windowSize - 1) / 2; //
			int beginIndex = interval;
			int endIndex = seqLen - interval - 1;
			for (int r = beginIndex; r <= endIndex; r++) {
				//System.out.println(r);
				double[][] sample = new double[windowSize][20];
				for (int j = 0; j < windowSize; j++) {
					sample[j] = pssm[r - interval + j];
				}
				//convert matrix to vector
				
				double [] a = AarrayUtil.matrix2vector(sample);				
				
				//save to a temp file
				PSSM.saveVector("./temp", "temp", a);				
				
				char flag = ProteinSeqAnalysis.getTMH_Flag(proteinCode, r +1);// жǷĤ 1Ĥ 0Ĥ
				
				// read the temp file as a String
				FileObject fo = new FileObject("./temp/temp");
				String str = new String(fo.getContents());
				if(flag == '1'){
					buf_1.append(str);
					buf_1.append("\n");
				}else{
					buf_0.append(str);
					buf_0.append("\n");
				}
			}			
		}
		//3.
		String sample_1 = buf_1.toString();
		sample_1 = sample_1.substring(0, sample_1.length() -1);
		String sample_0 = buf_0.toString();
		sample_0 = sample_0.substring(0, sample_0.length() -1);
		FileObject fo = new FileObject();
		fo.setContents(sample_1.getBytes());
		fo.writeToFile(dataBasePath + "/current", "train_"+windowSize+"_"+1+".mat");
		
		fo.setContents(sample_0.getBytes());
		fo.writeToFile(dataBasePath + "/current", "train_"+windowSize+"_"+0+".mat");
		
	}
}
