import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Vector;
import edu.njust.cs.bio.util.ProteinSeqAnalysis;
import edu.njust.cs.bio.performance.*;

public class Performance {
	private static void computeAccuracy(HashMap<String, Vector<int[]>> observedResult, HashMap<String, Integer> observedSeqLen, HashMap<String, Vector<int[]>> testingResult){
		//Step 1. testingSOMResultõԵ proteinCodeShort, ź		
		Object [] testingProteinCodeShort =  PerformanceAnalysis.getTestingProteinCodeShort(testingResult);
			
		//Step 2.  observedResult total number of TMHs
		int totalNumOfObservedTMHs = PerformanceAnalysis.getTotalTMHs(testingResult, observedResult);
		int totalNumOfProteinsToBePredicted = testingProteinCodeShort.length;
	
		System.out.println("Total Num of TMHs to be Predicted:" +  totalNumOfObservedTMHs);
		System.out.println("Total Num of Proteins to be Predicted:" +  totalNumOfProteinsToBePredicted);
		
		//Step 3.
		 int  vtmh= PerformanceAnalysis.getCorrectPredictedTMHs(testingResult, observedResult);
		 
		//Step 4.
		 int vp = PerformanceAnalysis.getCorrectPredictedProteins(testingResult, observedResult,false);
		 
		 // Step 5.
		 String n_score = PerformanceAnalysis.getN_C_Score(testingResult, observedResult, 'N');		 
		 String c_score = PerformanceAnalysis.getN_C_Score(testingResult, observedResult, 'C');
		
		 // Step 6.
		String  rmsd = PerformanceAnalysis.getRMSD(testingResult, observedResult, observedSeqLen);
		//System.out.println(rmsd);
		
		//
		DecimalFormat df = new DecimalFormat();
		df.applyPattern("#0.000");
		
		System.out.println("==================================================================");
		System.out.println("                            Vtmh       Vp          N-Score         C-Score           RMSD");
		System.out.println("                     "  + df.format((float)vtmh/(float)totalNumOfObservedTMHs)+ "    " + df.format((float)vp/(float)totalNumOfProteinsToBePredicted) + "   " +n_score+  "  " +c_score + "  " + rmsd);
	}
	public static void main(String[] args) {
		//PerformanceAnalysis.sortPredictionResult("./membrane-som/result/observedresult.fasta");
		 
		if (args.length != 1){
			System.out.println("Usage:   java Performance dataBasePath");
			System.out.println("e.g.:   java Performance ../db126");
		}
		
		String dataBasePath = args[0];
		System.out.println(dataBasePath);
		
		//-------------------------------------------
	
		// Observed Result
		HashMap<String, Vector<int[]>> observedResult = ProteinSeqAnalysis
				.getTransHelixArrayFromFile(dataBasePath + "/result/observed.fasta");
		HashMap<String, Integer> observedSeqLen = ProteinSeqAnalysis.getProteinSeqLen(dataBasePath + "/result/observed.fasta");
		
		//Testing Result
		/*
		HashMap<String, Vector<int[]>> testingResult_SOSUI = ProteinSeqAnalysis
		.getTransHelixArrayFromFile(dataBasePath + "/result/SOSUI.fasta");
		
		HashMap<String, Vector<int[]>> testingResult_DAS = ProteinSeqAnalysis
		.getTransHelixArrayFromFile(dataBasePath + "/result/DAS-TMfilter.fasta");
		
		HashMap<String, Vector<int[]>> testingResult_TOPPRED = ProteinSeqAnalysis
		.getTransHelixArrayFromFile(dataBasePath + "/result/TOP-PRED.fasta");
		
		HashMap<String, Vector<int[]>> testingResult_TMHMM = ProteinSeqAnalysis
		.getTransHelixArrayFromFile(dataBasePath + "/result/TMHMM.fasta");
		
		HashMap<String, Vector<int[]>> testingResult_Phobius = ProteinSeqAnalysis
		.getTransHelixArrayFromFile(dataBasePath + "/result/Phobius.fasta");
		
		HashMap<String, Vector<int[]>> testingResult_OCTOPUS = ProteinSeqAnalysis
		.getTransHelixArrayFromFile(dataBasePath + "/result/OCTOPUS.fasta");
		
		HashMap<String, Vector<int[]>> testingResult_Scampi_msa = ProteinSeqAnalysis
		.getTransHelixArrayFromFile(dataBasePath + "/result/Scampi-msa.fasta");
		
		HashMap<String, Vector<int[]>> testingResult_TOPCONS = ProteinSeqAnalysis
		.getTransHelixArrayFromFile(dataBasePath + "/result/TOPCONS.fasta");
				
		HashMap<String, Vector<int[]>> testingResult_MEMBRAIN = ProteinSeqAnalysis
		.getTransHelixArrayFromFile(dataBasePath + "/result/MemBrain.fasta");		
		
		*/

		HashMap<String, Vector<int[]>> testingResult_SOMPNN = ProteinSeqAnalysis.getTransHelixArrayFromFile(dataBasePath + "\\result\\predicted_SOMPNN.fasta");

		/*
		System.out.println("\nSOSUI");		
		computeAccuracy(observedResult, observedSeqLen, testingResult_SOSUI);
		
		System.out.println("\nDAS");		
		computeAccuracy(observedResult, observedSeqLen, testingResult_DAS);
		
		System.out.println("\nTOPPRED");		
		computeAccuracy(observedResult, observedSeqLen, testingResult_TOPPRED);
		
		System.out.println("\nTMHMM");
		computeAccuracy(observedResult, observedSeqLen, testingResult_TMHMM);
		
		System.out.println("\nPhobius");
		computeAccuracy(observedResult, observedSeqLen, testingResult_Phobius);
		
		System.out.println("\nOCTOPUS");
		computeAccuracy(observedResult, observedSeqLen, testingResult_OCTOPUS);
		
		System.out.println("\nScampi_msa");
		computeAccuracy(observedResult, observedSeqLen, testingResult_Scampi_msa);
		
		System.out.println("\nTOPCONS");
		computeAccuracy(observedResult, observedSeqLen, testingResult_TOPCONS);
		
		System.out.println("\nMEMBRAIN");
		computeAccuracy(observedResult, observedSeqLen, testingResult_MEMBRAIN);
		*/		
		computeAccuracy(observedResult, observedSeqLen, testingResult_SOMPNN);				
	}
}
