package edu.njust.cs.bio.protein;

import java.util.Arrays;
import java.util.Vector;
public class TMHSplitter {
	
	private static int length_for_segmentation = 30;  // ֻд length_for_segmentation ĲųԷָ
	private static int  miminal_length =9; // ָlength С10
	public static Vector<int []> getFinalTMHs(Vector<int []> initialTMHs,double[] propensity,double threshold,
			double step){
		Vector<int []> finalTMHs = new Vector<int []>();
		//
		for (int i = 0; i < initialTMHs.size(); i++) {
			int tmh_begin = initialTMHs.elementAt(i)[0];
			int tmh_end = initialTMHs.elementAt(i)[1];			
			Vector<int []> splitedTMH = splitTMH(propensity,
					tmh_begin, tmh_end, threshold, step);
			for (int j = 0; j < splitedTMH.size(); j++) {
				finalTMHs.add(splitedTMH.elementAt(j));
			}
		}
		return finalTMHs;
	}
	
	
	// TMH(from tmh_begin to tmh_end)ָΪTMH
	private static Vector<int []> splitTMH(double[] propensity,
			int tmh_begin, int tmh_end, double threshold_initial, double step) {
		
		if (tmh_end - tmh_begin < length_for_segmentation) { //  С30ָ			
			Vector<int []> splitTMHs = new Vector<int []>();
			int []  aTMH = new int [2];
			aTMH[0] = tmh_begin; // begin TMH
			aTMH[1] = tmh_end; // end TMH
			splitTMHs.add(aTMH);
			return splitTMHs;			
		} else {			
			Vector<int []> splitTMHs_OneRound = splitTMHOneRound(
					propensity, tmh_begin, tmh_end, threshold_initial, step);
			
			if (splitTMHs_OneRound.size() == 1) { // һַָȻΪ
				System.out.println("++ after split: ");
				for(int i = 0; i<splitTMHs_OneRound.size();i++){
					System.out.println(splitTMHs_OneRound.elementAt(i)[0]+"-"+splitTMHs_OneRound.elementAt(i)[1]);
				}
				
				return splitTMHs_OneRound;
			} else {
				Vector<int []> splitTMHs = new Vector<int []>();

				for (int i = 0; i < splitTMHs_OneRound.size(); i++) {
					int tmh_begin_seg = splitTMHs_OneRound.elementAt(i)[0];
					int tmh_end_seg = splitTMHs_OneRound.elementAt(i)[1];

					Vector<int []> temp_splitTMHs = splitTMH(
							propensity, tmh_begin_seg, tmh_end_seg,
							threshold_initial, step);
					for (int k = 0; k < temp_splitTMHs.size(); k++) {
						splitTMHs.addElement(temp_splitTMHs.elementAt(k));
					}
				}
				
				System.out.println("+++ after split: ");
				for(int i = 0; i<splitTMHs.size();i++){
					System.out.println(splitTMHs.elementAt(i)[0]+"-"+splitTMHs.elementAt(i)[1]);
				}
				
				return splitTMHs;
			}
		}
	}

	private static Vector<int []> splitTMHOneRound(double[] propensity,
			int tmh_begin, int tmh_end, double threshold_initial, double step) {
		Vector<int []> splitTMHs = new Vector<int []>();
		// 1. һЧָ
		double threshold;
		for ( threshold = threshold_initial; threshold <= 1.05; threshold += step) {
			splitTMHs.removeAllElements();
			double pre_score = -1;
			int begin_TMH = -1;
			int end_TMH = -1;
			
			for (int i = tmh_begin; i <= tmh_end; i++) {
				double score = propensity[i];
				if (pre_score < threshold && score >= threshold) {
					begin_TMH = i;
				}
				if (pre_score >= threshold && score < threshold) {
					end_TMH = i - 1;
					if (begin_TMH == -1) {
						int [] aTMH = new int [2];
						aTMH[0] = tmh_begin; // begin TMH
						aTMH[1] = end_TMH; // end TMH
						splitTMHs.add(aTMH);
					} else {
						int [] aTMH = new int[2];
						aTMH[0] = begin_TMH; // begin TMH
						aTMH[1] = end_TMH; // end TMH
						splitTMHs.add(aTMH);
					}
				}
				pre_score = propensity[i];
			}
			
			
			// System.out.println(" "+splitTMHs.size() );
			if (splitTMHs.size() >= 2) { // once split to 2 or more TMHs,
				// break;
			    boolean shouldImproveThreshold = false;
				for(int i  = 1; i < splitTMHs.size()  ; i ++){
					int segBegin = splitTMHs.elementAt(i)[0];
					int segEnd =  splitTMHs.elementAt(i-1)[1];
					//System.out.println("--------- :" +segEnd + "  " +segBegin );
					if(Math.abs(segBegin - segEnd) <=3){
						shouldImproveThreshold = true;
						break;
					}
				}
				if(shouldImproveThreshold && threshold < 1.0){
					continue;
				}else{
					break;
				}				
				
			}
		}
		// 2. ˣsplitTMHs.size() >= 0
		if (splitTMHs.size() == 0 || splitTMHs.size() == 1) {
			splitTMHs.removeAllElements();
			int [] tmh = new int [2];
			tmh[0] = tmh_begin;
			tmh[1] = tmh_end;
			splitTMHs.add(tmh);
		} else {
			boolean isAValidSegmentationRound = true;			
			splitTMHs.elementAt(0)[0] = tmh_begin; // reset TMH
			// begin
			splitTMHs.lastElement()[1] = tmh_end; // reset TMH
			// end
			
			mergeSamllTMH(splitTMHs);

            //1.
			for (int k = 0; k < splitTMHs.size(); k++) {
				int tmp_begin = splitTMHs.elementAt(k)[0];
				int tmp_end = splitTMHs.elementAt(k)[1];
				if (Math.abs(tmp_begin - tmp_end) < miminal_length) { // ָsegmentĳ
					// < 9,Чָ
					isAValidSegmentationRound = false;
					System.out.println(" Invalid :"+(tmp_begin +1)+"-"+(tmp_end+1));
				}
			}
			
			/*
           //2.ָǰ֮ļ <=4 ҲЧָ
			if(splitTMHs.size() > 1){
				for(int i  = 1; i < splitTMHs.size()  ; i ++){
					int segEnd =  splitTMHs.elementAt(i-1).elementAt(1);
					int segBegin = splitTMHs.elementAt(i).elementAt(0);
					//System.out.println("--------- :" +segEnd + "  " +segBegin );
					if(Math.abs(segBegin - segEnd) <=4){
						isAValidSegmentationRound = false;
						System.out.println("ָǰ֮ļ <=4 ҲЧָ\n--------- :" +(segEnd+1) + "-" +(segBegin+1) );
						break;
					}
				}
			}
			*/
			
			
			if (!isAValidSegmentationRound) {// Чָ
				splitTMHs.removeAllElements();
				int [] tmh = new int [2];
				tmh[0] = tmh_begin;
				tmh[1] = tmh_end;
				splitTMHs.add(tmh);
				
				System.out.println("");
			}
		}
		return splitTMHs;
	}
	
	
	public static  void mergeSamllTMH(Vector<int []> tmhV) {
		//Vector<Vector<Integer>> mergeredTMH = new Vector<Vector<Integer>>();
		int size = tmhV.size();
		if(size <=1)
			return;
		for(int i =  size - 1; i >=0 ; i --){
			int tmh_begin = tmhV.elementAt(i)[0];
			int tmh_end = tmhV.elementAt(i)[1];
			System.out.print(tmh_begin + " --" + tmh_end );
			
			if(Math.abs(tmh_begin - tmh_end) <=4){ //merge
				System.out.println("merge........................ i = " + i);
				if(i == 0){
					if(tmhV.size()>1){
						tmhV.elementAt(1)[0] = tmh_begin; // reset TMH
						tmhV.removeElementAt(0);
					}
				}else{
					tmhV.elementAt(i-1)[1] = tmh_end; // reset TMH
					tmhV.removeElementAt(i);
				}
			}
		}
	}
	
	
	public Vector<Vector<Integer>> mergeTMHs(Vector<Vector<Integer>> firstTMHs,
			Vector<Vector<Integer>> secondTMHs) {
		for (int i = 0; i < secondTMHs.size(); i++) {
			firstTMHs.add(secondTMHs.elementAt(i));
		}

		SortableVector[] a = new SortableVector[firstTMHs.size()];
		for (int i = 0; i < a.length; i++) {
			a[i] = new SortableVector(firstTMHs.elementAt(i));
		}

		Arrays.sort(a);

		firstTMHs.removeAllElements();
		for (int i = 0; i < a.length; i++) {
			firstTMHs.add(a[i].getValue());
		}

		return firstTMHs;
	}
}

class SortableVector implements java.lang.Comparable {
	Vector<Integer> v;

	public SortableVector(Vector<Integer> i_v) {
		v = i_v;
	}

	public int compareTo(Object o1) {
		Vector<Integer> v1 = ((SortableVector) o1).getValue();
		int tmh_begin_this = v.elementAt(0);
		int tmh_begin_in = v1.elementAt(0);
		if (tmh_begin_this < tmh_begin_in)
			return -1;
		else if (tmh_begin_this == tmh_begin_in)
			return 0;
		else
			return 1;
	}

	public Vector<Integer> getValue() {
		return v;
	}

}
