package edu.njust.cs.bio.util;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.*;
//FASTAʽļн
//룺 ļ protein sequence in FASTA format
// HashMap ( key = protein code long;  value =  protein sequence)
public class FASTAFileParser {
	public static HashMap <String, String>  parseProteinSeqs(String fileName) {
		//System.out.println("Begin Parsing FASTA Format File: " + fileName	+ " ...");
		HashMap <String, String>  proteinSeqs = new HashMap <String, String>  ();
		//FASTAFileParser.class.getResourceAsStream
		try {
			        
			BufferedReader in = new BufferedReader(new FileReader(fileName));

			String proteinCodeLong = ""; // eg. Q80WG7
			StringBuffer proteinSeq = new StringBuffer(); // eg. MSESEEISEF...

			String line = in.readLine();
			while (line != null) {
				//System.out.println(line);
				if (!line.startsWith("#")) { // Start with # is a line of
					// comment
					if (line.startsWith(">")) {
						if (!proteinCodeLong.equals("")) {
							String str = proteinSeq.toString();
							if (str.endsWith("\n"))
								str = str.substring(0, str.length() - 1);
							proteinSeqs.put(proteinCodeLong.trim(), str);
						}
						proteinCodeLong = line.substring(1,line.length());
						proteinSeq.delete(0, proteinSeq.length());
					} else {
						if (!line.equals(""))
							proteinSeq.append(line + "\n");
					}
				}
				line = in.readLine();
			}
			if (!proteinCodeLong.equals("")) {
				String str = proteinSeq.toString();
				if (str.endsWith("\n"))
					str = str.substring(0, str.length() - 1);
				proteinSeqs.put(proteinCodeLong.trim(), str);
			}
			in.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		//System.out.println("End Parsing FASTA Format File!");
		return proteinSeqs;
	}
}
