package edu.njust.cs.bio.util;

import java.util.HashMap;
import java.util.Set;
import java.util.Vector;

public class ProteinSeqAnalysis {
	
	public static float [] getTMH_Flags(Vector<int[]> trans , int seqLen){
		
		float [] flags = new float[seqLen];
		// 2. 0-1ַʾӦλõİǷڿĤ(1Ĥ 0Ĥ)
		for (int i = 0; i < seqLen; i++) {
			boolean isTrans = false; // ʼΪĤ
			for (int j = 0; j < trans.size(); j++) {
				int begin_tmh = trans.elementAt(j)[0];
				int end_tmh = trans.elementAt(j)[1];
				if ((i+1) >= begin_tmh && (i+1) <= end_tmh) {
					isTrans = true;
					break;
				}
			}
			if (isTrans) {
				flags[i] = 1;
			} else {
				flags[i] = 0;
			}
		}
		return flags;
		
	}
	
	// :3D_Helix_23 3-6 10-14
	// :ʽ
	//0
	//0
	//1
	//1
	//1
	//1
	//00011111000
	// ˵:0-1ַʾӦλõİǷڿĤ(1Ĥ 0Ĥ)
	public static String getTMH_Flags(String proteinCodeLong, String proteinSeq) {
		proteinSeq = proteinSeq.replaceAll("\n", ""); // ʹб
		int proteinSeqLen = proteinSeq.trim().length();
		// 1. proteinCodeгȡĤ
		Vector<int[]> trans = new Vector<int[]>();
		String workStr = proteinCodeLong;
		int index = workStr.indexOf('-');
		while (index != -1) {
			int beginIndex = -1;
			// ҵһ[ַ]
			int i = index - 1;
			for (; i >= 0; i--) {
				char cur_char = workStr.charAt(i);
				// System.out.println("["+cur_char+"]");
				if (!Character.isDigit(cur_char)) {
					break;
				}
			}
			beginIndex = i + 1;

			int endIndex = -1;
			// Ҳҵһ[ַ]
			i = index + 1;
			for (; i <= workStr.length() - 1; i++) {
				char cur_char = workStr.charAt(i);
				// System.out.println("["+cur_char+"]");
				if (!Character.isDigit(cur_char)) {
					// System.out.println("break");
					break;
				}
			}
			endIndex = i;

			// System.out.println(index);
			// System.out.println(beginIndex);
			// System.out.println(endIndex);

			int beginNum = Integer.parseInt(workStr
					.substring(beginIndex, index).trim());
			int endNum = Integer.parseInt(workStr
					.substring(index + 1, endIndex).trim());
			int[] tran = { beginNum, endNum };
			//System.out.println(beginNum);
			//System.out.println(endNum);

			trans.add(tran);
			workStr = workStr.substring(endIndex, workStr.length());
			// System.out.println("["+workStr+"]");
			index = workStr.indexOf('-');
		}
		// 2. 0-1ַʾӦλõİǷڿĤ(1Ĥ 0Ĥ)
		StringBuffer flags = new StringBuffer();
		for (int i = 1; i <= proteinSeqLen; i++) {
			boolean isTrans = false; // ʼΪĤ
			for (int j = 0; j < trans.size(); j++) {
				int begin_tmh = trans.elementAt(j)[0];
				int end_tmh = trans.elementAt(j)[1];
				if (i >= begin_tmh && i <= end_tmh) {
					isTrans = true;
					break;
				}
			}
			if (isTrans) {
				flags.append("1\n");
			} else {
				flags.append("0\n");
			}
		}
		return flags.toString().trim();
	}

	// :3D_Helix_23 3-6 10-14
	// :'0' '1'
	// ˵:жϵamino_acid_indexǷڿĤ(1Ĥ 0Ĥ)
	public static char getTMH_Flag(String proteinCodeLong, int amino_acid_index) {
		if(amino_acid_index<=0){
			System.out.println("ERROR: amino_acid_index should >=1 ");
			return '?';
		}
		// 1. proteinCodeгȡĤ
		Vector<int[]> trans = new Vector<int[]>();
		String workStr = proteinCodeLong;
		int index = workStr.indexOf('-');
		while (index != -1) {
			int beginIndex = -1;
			// ҵһ[ַ]
			int i = index - 1;
			for (; i >= 0; i--) {
				char cur_char = workStr.charAt(i);
				// System.out.println("["+cur_char+"]");
				if (!Character.isDigit(cur_char)) {
					break;
				}
			}
			beginIndex = i + 1;

			int endIndex = -1;
			// Ҳҵһ[ַ]
			i = index + 1;
			for (; i <= workStr.length() - 1; i++) {
				char cur_char = workStr.charAt(i);
				// System.out.println("["+cur_char+"]");
				if (!Character.isDigit(cur_char)) {
					// System.out.println("break");
					break;
				}
			}
			endIndex = i;

			// System.out.println(index);
			// System.out.println(beginIndex);
			// System.out.println(endIndex);

			int beginNum = Integer.parseInt(workStr
					.substring(beginIndex, index).trim());
			int endNum = Integer.parseInt(workStr
					.substring(index + 1, endIndex).trim());
			int[] tran = { beginNum, endNum };
			//System.out.println(beginNum);
			//System.out.println(endNum);

			trans.add(tran);
			workStr = workStr.substring(endIndex, workStr.length());
			// System.out.println("["+workStr+"]");
			index = workStr.indexOf('-');
		}
		// 2. жǷڿĤ(1Ĥ 0Ĥ)
		boolean isTrans = false; // ʼΪĤ
		for (int j = 0; j < trans.size(); j++) {
			int begin_tmh = trans.elementAt(j)[0];
			int end_tmh = trans.elementAt(j)[1];
			if (amino_acid_index >= begin_tmh && amino_acid_index <= end_tmh) {
				isTrans = true;
				break;
			}
		}
		if (isTrans) {
			return '1';
		} else {
			return '0';
		}
	}
	

	//key : proteinCodeShort
	//value: Integer
	public static HashMap <String, Integer>  getProteinSeqLen(String fileName) {
		HashMap <String, Integer> result = new HashMap <String, Integer>();		
		    HashMap<String, String> proteinSeqs = FASTAFileParser
					.parseProteinSeqs(fileName);
			Set<String> keys = proteinSeqs.keySet();
			Object[] keysArray = keys.toArray();		
			
			for (int i = 0; i < keysArray.length; i++) {
				String proteinCode = (String) keysArray[i];
				int index = proteinCode.indexOf(" ");					
				String proteinCodeShort = proteinCode.substring(0, index);
			    
				String proteinSeq = 	proteinSeqs.get(proteinCode);
				proteinSeq = proteinSeq.replaceAll("\n", ""); // ʹб
				int proteinSeqLen = proteinSeq.trim().length();
				
				result.put(proteinCodeShort, new Integer(proteinSeqLen));
			}				
			return result;
		}	
	
	//key : proteinCodeShort
	//value: Vector<int[]>
	public static HashMap <String, Vector<int[]>>  getTransHelixArrayFromFile(String fileName) {
		HashMap <String, Vector<int[]>> result = new HashMap <String, Vector<int[]>>();		
		    HashMap<String, String> proteinSeqs = FASTAFileParser
					.parseProteinSeqs(fileName);
			Set<String> keys = proteinSeqs.keySet();
			Object[] keysArray = keys.toArray();		
			
			for (int i = 0; i < keysArray.length; i++) {
				String proteinCode = (String) keysArray[i];
				int index = proteinCode.indexOf(" ");					
				String proteinCodeShort = proteinCode.substring(0, index);
				
				Vector<int[]> transHelixFields = ProteinSeqAnalysis.getTransHelixArray(proteinCode);
				result.put(proteinCodeShort, transHelixFields);
			}				
			return result;
		}	
	// :3D_Helix_23 3-6 10-14
	// : int [] array = {{3,6},{10,14}};
	// ˵:proteinCodeн
	public static Vector<int[]> getTransHelixArray(String proteinCodeLong){
		// 1. proteinCodeгȡĤ
		Vector<int[]> trans = new Vector<int[]>();
		String workStr = proteinCodeLong;
		int index = workStr.indexOf('-');
		while (index != -1) {
			int beginIndex = -1;
			// ҵһ[ַ]
			int i = index - 1;
			for (; i >= 0; i--) {
				char cur_char = workStr.charAt(i);
				// System.out.println("["+cur_char+"]");
				if (!Character.isDigit(cur_char)) {
					break;
				}
			}
			beginIndex = i + 1;

			int endIndex = -1;
			// Ҳҵһ[ַ]
			i = index + 1;
			for (; i <= workStr.length() - 1; i++) {
				char cur_char = workStr.charAt(i);
				// System.out.println("["+cur_char+"]");
				if (!Character.isDigit(cur_char)) {
					// System.out.println("break");
					break;
				}
			}
			endIndex = i;

			// System.out.println(index);
			// System.out.println(beginIndex);
			// System.out.println(endIndex);

			int beginNum = Integer.parseInt(workStr
					.substring(beginIndex, index).trim());
			int endNum = Integer.parseInt(workStr
					.substring(index + 1, endIndex).trim());
			int[] tran = { beginNum, endNum };
			trans.add(tran);
			workStr = workStr.substring(endIndex, workStr.length());
			// System.out.println("["+workStr+"]");
			index = workStr.indexOf('-');
		}
		return trans;
	}
}
