package edu.njust.cs.util;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.net.URLClassLoader;

//(-ֵ)༭Ի
public class AttrValueEditor extends JDialog implements ActionListener {
	private static final long serialVersionUID = -6498789783221516551L;
	public final static int OK = 1;
	public final static int CANCEL = -1;
	public final static int CLOSE = 0;
	protected int action = CANCEL; // Ĭ϶

	public final static int TYPE_EDIT = 0;
	public final static int TYPE_ADD = 1;
	public int dialogType = 1; // Ĭ

	protected JLabel labAttr = new JLabel("      ");
	protected JTextField txtAttr = new JTextField();
	protected JLabel labValue = new JLabel("    ֵ  ");
	protected JTextField txtValue = new JTextField();

	protected JButton btnOk = new JButton("ȷ(Yes)");
	protected JButton btnCancel = new JButton("ȡ(Esc)");
	private JLabel labDesp = new JLabel();

	protected JFrame father = null;
	protected JPanel cp = new JPanel();// 
	protected JPanel ap = new JPanel();// 
	protected Insets insets = new Insets(2, 2, 2, 2);
	protected URLClassLoader urlLoader;
	protected TransferFocusListener tfl = new TransferFocusListener();

	private String[] attrAndValue = null;

	public AttrValueEditor(JFrame i_father, boolean i_isModal,
			int i_dialogType, String[] i_attrAndValue) {
		super(i_father, i_isModal);
		this.father = i_father;
		this.dialogType = i_dialogType;
		this.attrAndValue = i_attrAndValue;

		if (this.dialogType == TYPE_EDIT)
			this.setTitle("޸");
		if (this.dialogType == TYPE_ADD)
			this.setTitle("");

		urlLoader = (URLClassLoader) this.getClass().getClassLoader();
		btnOk.addActionListener(this);
		btnCancel.addActionListener(this);
		btnOk.setIcon(new ImageIcon(urlLoader.findResource("image/ok20.gif")));
		btnCancel.setIcon(new ImageIcon(urlLoader
				.findResource("image/cancel20.gif")));

		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				action = CLOSE;
			}
		});
		this.getContentPane().setLayout(new BorderLayout());

		ap.setLayout(new GridBagLayout());
		LayoutUtil.add(ap, GridBagConstraints.HORIZONTAL,
				GridBagConstraints.CENTER, 100, 0, 0, 0, 1, 1, new JLabel(),
				insets);
		LayoutUtil.add(ap, GridBagConstraints.NONE, GridBagConstraints.CENTER,
				0, 0, 1, 0, 1, 1, this.btnOk, insets);
		LayoutUtil.add(ap, GridBagConstraints.NONE, GridBagConstraints.CENTER,
				0, 0, 2, 0, 1, 1, this.btnCancel, insets);

		this.getContentPane().add(ap, "South");
		this.setResizable(false);

		txtAttr.addActionListener(tfl);
		txtValue.addActionListener(tfl);
		this.getRootPane().setDefaultButton(this.btnOk);

		this.btnCancel.setMnemonic(KeyEvent.VK_E);
		this.btnCancel.registerKeyboardAction(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cancelClicked();
			}
		}, KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0),
				JComponent.WHEN_IN_FOCUSED_WINDOW);

		// begin desp
		labDesp.setFont(new Font("", 1, 16));
		labDesp.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		labDesp.setIcon(new ImageIcon(urlLoader
				.findResource("image/document20.gif")));
		labDesp.setText("(-ֵ)");
		getContentPane().add(labDesp, "North");
		// end desp
		// begin cp
		cp.setLayout(new GridBagLayout());
		cp.setBorder(BorderFactory.createEtchedBorder());
		LayoutUtil.add(cp, GridBagConstraints.NONE, GridBagConstraints.CENTER,
				0, 0, 0, 0, 1, 1, labAttr, insets);
		LayoutUtil.add(cp, GridBagConstraints.HORIZONTAL,
				GridBagConstraints.CENTER, 100, 0, 1, 0, 1, 1, txtAttr, insets);
		LayoutUtil.add(cp, GridBagConstraints.NONE, GridBagConstraints.CENTER,
				0, 0, 0, 1, 1, 1, labValue, insets);
		LayoutUtil
				.add(cp, GridBagConstraints.HORIZONTAL,
						GridBagConstraints.CENTER, 100, 0, 1, 1, 1, 1,
						txtValue, insets);
		this.getContentPane().add(cp, "Center");
		// end cp
		setSizeAndPosition(400, 200);
		initEditor();
	}

	public void setSizeAndPosition(int w, int h) {
		this.setSize(w, h);
		Dimension d = father.getSize();
		Point pp = father.getLocation();
		this.setLocation(pp.x + (d.width - w) / 2, pp.y + (d.height - h) / 2);
	}

	public int getAction() {
		return action;
	}

	public void initEditor() {
		if (this.dialogType == AttrValueEditor.TYPE_ADD) {
			this.txtAttr.setText("");
			this.txtValue.setText("");
		}
		if (this.dialogType == AttrValueEditor.TYPE_EDIT) {
			this.txtAttr.setText(attrAndValue[0]);
			this.txtValue.setText(attrAndValue[1]);
		}
	}

	public void actionPerformed(ActionEvent e) {
		Object s = e.getSource();
		if (s == btnOk) {
			if (this.isDataValid())
				okClicked();
		} else if (s == btnCancel) {
			cancelClicked();
		}
	}

	public void cancelClicked() {
		action = CANCEL;
		setVisible(false);
	}

	// ҪУ鷽
	public boolean isDataValid() {
		if (txtAttr.getText().trim().equals("")
				|| txtValue.getText().trim().equals("")) {
			JOptionPane.showMessageDialog(father, "[][ֵ]Ϊ!", "ʾ",
					JOptionPane.INFORMATION_MESSAGE);
			return false;
		}
		return true;
	}

	public void okClicked() {
		if (attrAndValue == null)
			attrAndValue = new String[2];
		attrAndValue[0] = this.txtAttr.getText().trim();
		attrAndValue[1] = this.txtValue.getText().trim();
		action = OK;
		setVisible(false);
	}

	public String[] getAttrAndValue() {
		return attrAndValue;
	}
}