package edu.njust.cs.util;

import java.sql.*;

//ݿ⹤
public class DBU {
	private static int MAX_RETURNED_ROWS = 2000; // 󷵻ؼ¼

	public static PreparedStatement getPreparedStatement(Connection con,
			String sql, int maxRows) throws Exception {
		if (maxRows < 0)
			maxRows = MAX_RETURNED_ROWS;

		PreparedStatement ps = con.prepareStatement(sql);
		ps.setMaxRows(maxRows);
		return ps;
	}

	public static PreparedStatement getPreparedStatement(Connection con,
			String sql) throws Exception {
		PreparedStatement ps = con.prepareStatement(sql);
		ps.setMaxRows(MAX_RETURNED_ROWS);
		return ps;
	}

	public static Statement getStatement(Connection con, int maxRows)
			throws Exception {
		if (maxRows < 0)
			maxRows = MAX_RETURNED_ROWS;
		Statement st = con.createStatement();
		st.setMaxRows(maxRows);
		return st;
	}

	public static Statement getStatement(Connection con) throws Exception {
		Statement st = con.createStatement();
		st.setMaxRows(MAX_RETURNED_ROWS);
		return st;
	}

	public static void close(PreparedStatement ps) {
		try {
			if (ps != null)
				ps.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void close(Statement st) {
		try {
			if (st != null)
				st.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void close(ResultSet rs) {
		try {
			if (rs != null)
				rs.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void close(Connection con) {
		try {
			if (con != null)
				con.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void setAutoCommit(Connection con, boolean flag) {
		try {
			if (con != null)
				con.setAutoCommit(flag);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
