package edu.njust.cs.util;

import java.sql.Timestamp;
import java.text.DecimalFormat;
import java.util.*;

public class DateUtil {
	private static DecimalFormat df = new DecimalFormat();

	public static String getLogTime() {
		return "[" + DateUtil.getCurrentYMDHMSMS() + "] ";
	}

	// --------------------------------------------------------------------
	// ݸһȺ·,øȺµʼʱ
	//   2003-09 ֵΪ ʼʱΪ 2003-09-01 00:00:00.0
	public static Timestamp getBeginYearMonthTimestamp(int year, int month) {
		GregorianCalendar beginGC = new GregorianCalendar(year, month - 1, 1,
				0, 0, 0);
		return new Timestamp(beginGC.getTimeInMillis());
	}

	// ݸһȺ·,øȺµֹʱ
	//   2003-09 ֵΪ ֹʱΪ 2003-10-01 00:00:00.0
	public static Timestamp getEndYearMonthTimestamp(int year, int month) {
		GregorianCalendar endGC = new GregorianCalendar(year, month, 1, 0, 0, 0);
		return new Timestamp(endGC.getTimeInMillis());
	}

	// --------------------------------------------------------------------
	// ݸһ,øȵʼʱ
	//   2003 ôʱȵʼʱΪ 2003-01-01 00:00:00.0
	public static Timestamp getBeginYearTimestamp(int year) {
		GregorianCalendar beginGC = new GregorianCalendar(year, 0, 1, 0, 0, 0);
		return new Timestamp(beginGC.getTimeInMillis());
	}

	// ݸһ,øȵĵֹʱ
	//   2003 ôʱȵֹʱΪ 2004-01-01 00:00:00.0
	public static Timestamp getEndYearTimestamp(int year) {
		GregorianCalendar endGC = new GregorianCalendar(year + 1, 0, 1, 0, 0, 0);
		return new Timestamp(endGC.getTimeInMillis());
	}

	// 2003 Ҫҳ2003ڵ ʹ÷
	// Timestamp begin=DateUtil.getBeginYearTimestamp(2003);
	// Timestamp end=DateUtil.getEndYearTimestamp(2003);
	// select * from table where rq>=begin and rq<end;
	// -------------------------------------------------------------------

	//  2003-11-24 ĸʽΪ TimeStamp ʽ
	public static Timestamp getTimeStampFromYear_Month_Day(String s) {
		int year = Integer.parseInt(s.substring(0, 4));
		int month = Integer.parseInt(s.substring(5, 7));
		int day = Integer.parseInt(s.substring(8, 10));
		GregorianCalendar gc = new GregorianCalendar(year, month - 1, day, 0,
				0, 0);
		return new Timestamp(gc.getTimeInMillis());
	}

	// ȡõǰ 20031128 (8λ)
	public static String getCurrentYearMonthDay() {
		GregorianCalendar gc = new GregorianCalendar();
		String m = "";
		if ((gc.get(Calendar.MONTH) + 1) < 10)
			m = "0" + (gc.get(Calendar.MONTH) + 1);
		else
			m = "" + (gc.get(Calendar.MONTH) + 1);
		String d = "";
		if (gc.get(Calendar.DAY_OF_MONTH) < 10)
			d = "0" + gc.get(Calendar.DAY_OF_MONTH);
		else
			d = "" + gc.get(Calendar.DAY_OF_MONTH);

		return (gc.get(Calendar.YEAR)) + m + d;
	}

	// TIMESTAMP Ϊ 2003-11-28 ĸʽ
	public static String getYear_Month_DayFromTimeStamp(Timestamp tp) {
		GregorianCalendar gc = new GregorianCalendar();
		gc.setTimeInMillis(tp.getTime());
		String m = "";
		if ((gc.get(Calendar.MONTH) + 1) < 10)
			m = "0" + (gc.get(Calendar.MONTH) + 1);
		else
			m = "" + (gc.get(Calendar.MONTH) + 1);
		String d = "";
		if (gc.get(Calendar.DAY_OF_MONTH) < 10)
			d = "0" + gc.get(Calendar.DAY_OF_MONTH);
		else
			d = "" + gc.get(Calendar.DAY_OF_MONTH);

		return (gc.get(Calendar.YEAR)) + "-" + m + "-" + d;
	}

	// TIMESTAMP Ϊ 20031128 ĸʽ
	public static String getYearMonthDayFromTimeStamp(Timestamp tp) {
		GregorianCalendar gc = new GregorianCalendar();
		gc.setTimeInMillis(tp.getTime());
		String m = "";
		if ((gc.get(Calendar.MONTH) + 1) < 10)
			m = "0" + (gc.get(Calendar.MONTH) + 1);
		else
			m = "" + (gc.get(Calendar.MONTH) + 1);
		String d = "";
		if (gc.get(Calendar.DAY_OF_MONTH) < 10)
			d = "0" + gc.get(Calendar.DAY_OF_MONTH);
		else
			d = "" + gc.get(Calendar.DAY_OF_MONTH);
		return (gc.get(Calendar.YEAR)) + m + d;
	}

	// gc Ϊ 2003-11-28 ĸʽ
	public static String getYear_Month_DayFromGregorianCalendar(
			GregorianCalendar gc) {

		String m = "";
		if ((gc.get(Calendar.MONTH) + 1) < 10)
			m = "0" + (gc.get(Calendar.MONTH) + 1);
		else
			m = "" + (gc.get(Calendar.MONTH) + 1);
		String d = "";
		if (gc.get(Calendar.DAY_OF_MONTH) < 10)
			d = "0" + gc.get(Calendar.DAY_OF_MONTH);
		else
			d = "" + gc.get(Calendar.DAY_OF_MONTH);

		return (gc.get(Calendar.YEAR)) + "-" + m + "-" + d;
	}

	// gc Ϊ 20031128 ĸʽ
	public static String getYearMonthDayFromGregorianCalendar(
			GregorianCalendar gc) {

		String m = "";
		if ((gc.get(Calendar.MONTH) + 1) < 10)
			m = "0" + (gc.get(Calendar.MONTH) + 1);
		else
			m = "" + (gc.get(Calendar.MONTH) + 1);
		String d = "";
		if (gc.get(Calendar.DAY_OF_MONTH) < 10)
			d = "0" + gc.get(Calendar.DAY_OF_MONTH);
		else
			d = "" + gc.get(Calendar.DAY_OF_MONTH);
		return (gc.get(Calendar.YEAR)) + m + d;
	}

	// gc Ϊ 2003-11-28 00:00:00ĸʽ
	public static String getYear_Month_Day_Hour_Minute_SecondFromGregorianCalendar(
			GregorianCalendar gc) {
		String yearMonthDay = getYear_Month_DayFromTimeStamp(getTimestampFromGregorianCalendar(gc));
		String hour = "";
		String minute = "";
		String second = "";
		if (gc.get(Calendar.HOUR_OF_DAY) < 10)
			hour = "0" + gc.get(Calendar.HOUR_OF_DAY);
		else
			hour = "" + gc.get(Calendar.HOUR_OF_DAY);
		if (gc.get(Calendar.MINUTE) < 10)
			minute = "0" + gc.get(Calendar.MINUTE);
		else
			minute = "" + gc.get(Calendar.MINUTE);
		if (gc.get(Calendar.SECOND) < 10)
			second = "0" + gc.get(Calendar.SECOND);
		else
			second = "" + gc.get(Calendar.SECOND);
		return yearMonthDay + " " + hour + ":" + minute + ":" + second;
	}

	// gc Ϊ 20031128 00:00:00ĸʽ add by cxl
	public static String getYearMonthDay_Hour_Minute_SecondFromGregorianCalendar(
			GregorianCalendar gc) {
		String yearMonthDay = getYearMonthDayFromTimeStamp(getTimestampFromGregorianCalendar(gc));
		String hour = "";
		String minute = "";
		String second = "";
		if (gc.get(Calendar.HOUR_OF_DAY) < 10)
			hour = "0" + gc.get(Calendar.HOUR_OF_DAY);
		else
			hour = "" + gc.get(Calendar.HOUR_OF_DAY);
		if (gc.get(Calendar.MINUTE) < 10)
			minute = "0" + gc.get(Calendar.MINUTE);
		else
			minute = "" + gc.get(Calendar.MINUTE);
		if (gc.get(Calendar.SECOND) < 10)
			second = "0" + gc.get(Calendar.SECOND);
		else
			second = "" + gc.get(Calendar.SECOND);
		return yearMonthDay + " " + hour + ":" + minute + ":" + second;
	}

	public static Timestamp getTimestampFromYearMonthDay_Hour_Minute_Second14(String s){
		//s = 20031128000000
		int year = Integer.parseInt(s.substring(0, 4));
		int month = Integer.parseInt(s.substring(4, 6));
		int day = Integer.parseInt(s.substring(6, 8));

		int hour = Integer.parseInt(s.substring(8, 10));
		int minute = Integer.parseInt(s.substring(10, 12));
		int second = Integer.parseInt(s.substring(12, 14));

		GregorianCalendar gc = new GregorianCalendar(year, month - 1, day,
				hour, minute, second);
		return new Timestamp(gc.getTimeInMillis());
	}
	
	// gc Ϊ 20031128000000ĸʽ add by cxl
	public static String getYearMonthDay_Hour_Minute_Second14FromGregorianCalendar(
			GregorianCalendar gc) {
		String yearMonthDay = getYearMonthDayFromTimeStamp(getTimestampFromGregorianCalendar(gc));
		String hour = "";
		String minute = "";
		String second = "";
		if (gc.get(Calendar.HOUR_OF_DAY) < 10)
			hour = "0" + gc.get(Calendar.HOUR_OF_DAY);
		else
			hour = "" + gc.get(Calendar.HOUR_OF_DAY);
		if (gc.get(Calendar.MINUTE) < 10)
			minute = "0" + gc.get(Calendar.MINUTE);
		else
			minute = "" + gc.get(Calendar.MINUTE);
		if (gc.get(Calendar.SECOND) < 10)
			second = "0" + gc.get(Calendar.SECOND);
		else
			second = "" + gc.get(Calendar.SECOND);
		return yearMonthDay + hour + minute + second;
	}

	public static String getHourMinuteFromGregorianCalendar(GregorianCalendar gc) {
		String hour = "";
		String minute = "";
		if (gc.get(Calendar.HOUR_OF_DAY) < 10)
			hour = "0" + gc.get(Calendar.HOUR_OF_DAY);
		else
			hour = "" + gc.get(Calendar.HOUR_OF_DAY);
		if (gc.get(Calendar.MINUTE) < 10)
			minute = "0" + gc.get(Calendar.MINUTE);
		else
			minute = "" + gc.get(Calendar.MINUTE);

		return hour + minute;
	}

	//  2003-11-24 22:10:78ĸʽΪ TimeStamp ʽ
	public static Timestamp getTimeStampFromYear_Month_Day_Hour_Minute_Second(
			String s) {
		int year = Integer.parseInt(s.substring(0, 4));
		int month = Integer.parseInt(s.substring(5, 7));
		int day = Integer.parseInt(s.substring(8, 10));

		int hour = Integer.parseInt(s.substring(11, 13));
		int minute = Integer.parseInt(s.substring(14, 16));
		int second = Integer.parseInt(s.substring(17, 19));

		GregorianCalendar gc = new GregorianCalendar(year, month - 1, day,
				hour, minute, second);
		return new Timestamp(gc.getTimeInMillis());
	}

	// GregorianCalendarΪTIMESTAMP ĸʽ
	public static Timestamp getTimestampFromGregorianCalendar(
			GregorianCalendar gc) {
		return new Timestamp(gc.getTimeInMillis());
	}

	// TIMESTAMP Ϊ GregorianCalendarĸʽ

	public static GregorianCalendar getGregorianCalendarFrameTimestap(
			Timestamp ts) {
		GregorianCalendar gc = new GregorianCalendar();
		gc.setTimeInMillis(ts.getTime());
		return gc;
	}

	//
	// жǷΪЧʱʽ (4λ)-(2λ)-(2λ) ʱ(2λ)-(2λ)-(2λ)  2003-11-07 10:33:32
	public static boolean isValidYear_Month_Day_Hour_Minute_SecondDateFormat(
			String s) {
		boolean flag = true;
		if (s.length() < 19) {
			return false;
		}
		try {
			Integer.parseInt(s.substring(0, 4));
			Integer.parseInt(s.substring(5, 7));
			Integer.parseInt(s.substring(8, 10));
			Integer.parseInt(s.substring(11, 13));
			Integer.parseInt(s.substring(14, 16));
			Integer.parseInt(s.substring(17, 19));
		} catch (Exception e) {
			System.out.println(e);
			flag = false;
		}
		return flag;
	}

	// жǷΪЧʱʽ (4λ)-(2λ)-(2λ)  2003-11-07
	public static boolean isValidYear_Month_Day_DateFormat(String s) {
		boolean flag = true;
		if (s.length() != 10) {
			return false;
		}
		try {
			Integer.parseInt(s.substring(0, 4));
			Integer.parseInt(s.substring(5, 7));
			Integer.parseInt(s.substring(8, 10));
		} catch (Exception e) {
			System.out.println(e);
			flag = false;
		}
		return flag;
	}

	public static boolean isValidYear_Month_DateFormat(String s) {
		boolean flag = true;
		if (s.length() != 7) {
			return false;
		}
		try {
			Integer.parseInt(s.substring(0, 4));
			Integer.parseInt(s.substring(5, 7));
		} catch (Exception e) {
			System.out.println(e);
			flag = false;
		}
		return flag;
	}

	public static GregorianCalendar getGregorianCalendarFromYearMonthDay(
			String yearMonthDay) {
		String year = yearMonthDay.substring(0, 4);
		String month = yearMonthDay.substring(4, 6);
		String day = yearMonthDay.substring(6, 8);
		return new GregorianCalendar(Integer.parseInt(year), Integer
				.parseInt(month) - 1, Integer.parseInt(day));
	}

	// ȡõǰģʱ 200
	public static String getCurrentYMDHMSMS() {
		Timestamp ts = new Timestamp(System.currentTimeMillis());
		GregorianCalendar gc = DateUtil.getGregorianCalendarFrameTimestap(ts);
		String yearMonthDay = getYearMonthDayFromTimeStamp(getTimestampFromGregorianCalendar(gc));
		String hour = "";
		String minute = "";
		String second = "";
		int miliSecond = 0;
		if (gc.get(Calendar.HOUR_OF_DAY) < 10)
			hour = "0" + gc.get(Calendar.HOUR_OF_DAY);
		else
			hour = "" + gc.get(Calendar.HOUR_OF_DAY);
		if (gc.get(Calendar.MINUTE) < 10)
			minute = "0" + gc.get(Calendar.MINUTE);
		else
			minute = "" + gc.get(Calendar.MINUTE);
		if (gc.get(Calendar.SECOND) < 10)
			second = "0" + gc.get(Calendar.SECOND);
		else
			second = "" + gc.get(Calendar.SECOND);

		miliSecond = gc.get(Calendar.MILLISECOND);
		df.applyPattern("000");
		return yearMonthDay + "_" + hour + "_" + minute + "_" + second + "_"
				+ df.format(miliSecond);
	}

	public static String convert8YMDTo10YMD(String YMD8) {
		StringBuffer buf = new StringBuffer(YMD8);
		buf.insert(6, '-');
		buf.insert(4, '-');
		return buf.toString().trim();
	}
	// ȡõǰģʱ 200
	public static String getCurrentHMS() {
		Timestamp ts = new Timestamp(System.currentTimeMillis());
		GregorianCalendar gc = DateUtil.getGregorianCalendarFrameTimestap(ts);
	//	String yearMonthDay = getYearMonthDayFromTimeStamp(getTimestampFromGregorianCalendar(gc));
		String hour = "";
		String minute = "";
		String second = "";
	//	int miliSecond = 0;
		if (gc.get(Calendar.HOUR_OF_DAY) < 10)
			hour = "0" + gc.get(Calendar.HOUR_OF_DAY);
		else
			hour = "" + gc.get(Calendar.HOUR_OF_DAY);
		if (gc.get(Calendar.MINUTE) < 10)
			minute = "0" + gc.get(Calendar.MINUTE);
		else
			minute = "" + gc.get(Calendar.MINUTE);
		if (gc.get(Calendar.SECOND) < 10)
			second = "0" + gc.get(Calendar.SECOND);
		else
			second = "" + gc.get(Calendar.SECOND);

	//	miliSecond = gc.get(Calendar.MILLISECOND);
		df.applyPattern("000");
		return hour  + minute + second;
	}
}