package edu.njust.cs.util;

import java.io.*;


public class FileObject {
	public byte[] contents = null;

	public FileObject() {

	}
	public FileObject(byte[] contents) {
		this.contents = contents;
	}
    
	public FileObject(String absoluteFileName){
		try {
			File file = new File(absoluteFileName);			
			FileInputStream in = new FileInputStream(file);
			int size = in.available();
			contents = new byte[size];
			in.read(contents);
			in.close();
		} catch (Exception e) {
			e.printStackTrace();
			contents = null;
		}
	}
	public void setContents(byte[] contents) {
		this.contents = contents;
	}
	public byte [] getContents(){
		return this.contents;
	}
	public void writeToFile(String path, String fileName) {
		try {
			File pathFile = new File(path);
			if(!pathFile.exists())
				pathFile.mkdirs();
			
			File file = new File(path + System.getProperties().getProperty("file.separator") + fileName);
			FileOutputStream out = new FileOutputStream(file);
			out.write(contents);
			out.flush();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	
}
