package edu.njust.cs.util;


import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;

public class FileSystemUtil {
	
	public static void saveFile(String path, String name, byte[] fileData) throws Exception
	{
		File pathFile = new File(path);
		if(!pathFile.exists())
			pathFile.mkdirs();
    	FileOutputStream out=null;
    	try{
			out=new FileOutputStream(new File(path + System.getProperty("file.separator") + name));
			out.write(fileData);
		}catch(Exception e){
			throw new Exception("ļʱִ\n"+e.toString());
		}finally{
			if(out!=null) out.close();
		}
	}
	
    public static byte[] readFile(String fileName) throws Exception
    {
 
    	FileInputStream in=null;
    	try{
  		  in=new FileInputStream(fileName);
  		  int size=in.available();
  		  byte [] dataBytes =new byte[size];
  		  in.read(dataBytes); 
  		  return dataBytes;
  		  
  		}catch(Exception e){
  			throw new Exception("ȡļʱִ\n"+e.toString());
  		}finally{
  			if(in!=null) in.close();
  		}

    }
    /**Added by WUSS on 2008-03-31
     *	srcFileName---·ļ
     *	desFileName---·ļ
     */
    public static boolean MoveFile(String srcFileName, String desPath, String desFileName) throws Exception
	{	
		File src = new File(srcFileName);
		if (!src.exists())
		{
			throw new Exception("ļ " + srcFileName + " !");		
		}
		
		File path=new File(desPath);
		if (!path.exists())
		{
			path.mkdirs();
		}
		
		boolean r = false;
		try{
			r=src.renameTo(new File(desFileName));
		}catch(SecurityException se){
			throw new Exception("Ųļְȫ쳣:" + se.toString());
		}catch(NullPointerException npe){
			throw new Exception("ŲļʱδָĿļ");
		}
		
		return r;

	}
    
	public static boolean isValidPath(String path){
		boolean flag=true;
		
		try{
			File f=new File(path);
			if(!f.exists()||!f.isDirectory()){
				flag=false;
			}	
		}catch(Exception e){
			flag=false;
		}
		return flag;
	}
	
	public  static boolean isValidFile(String path){
		boolean flag=true;
		try{
			File f=new File(path);
			if(!f.exists()||!f.isFile()){
				flag=false;
			}	
		}catch(Exception e){
			flag=false;
		}
		return flag;
	}

}
