package edu.njust.cs.util;

import java.awt.BorderLayout;
import java.awt.Toolkit;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.InputVerifier;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFormattedTextField;
import javax.swing.JFrame;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.BadLocationException;

public class IPTextField extends JFormattedTextField{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static final Pattern pat = Pattern.compile("\\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\." +
            "(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\." +
            "(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\." +
            "(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\b");
    public static boolean checkString(String s) {
        Matcher m = pat.matcher(s);
        return m.matches();
    }
    public String getIP(){
    	return this.getText();
    }
    public IPTextField(){
    	
    	setInputVerifier(new InputVerifier() {
            public boolean shouldYieldFocus(JComponent input) {
                boolean inputOK = verify(input);
                if (inputOK) {
                    return true;
                } else {
                    Toolkit.getDefaultToolkit().beep();
                    System.out.println("beep");
                    return false;
                }
            }
            public boolean verify(JComponent input) {
                JTextField field = (JTextField) input;
                return checkString(field.getText());
            }
        });
    }
    
    public static void main(String [] args){
    	JFrame frame = new JFrame();
    	final IPTextField ipField = new IPTextField();
    	final JButton button = new JButton("A");
    	frame.add(ipField, BorderLayout.NORTH);
        frame.add(button, BorderLayout.CENTER);
        frame.add(new JButton("Another Button"), BorderLayout.SOUTH);     
        
        
        ipField.getDocument().addDocumentListener(new DocumentListener() {
            void checkDocument(DocumentEvent e) {
                try {
                    String currentText = e.getDocument().getText(0, e.getDocument().getLength());
                    System.out.println(currentText);
                    if( checkString(currentText)){
                    	button.setEnabled(true);
                    }else{
                    	button.setEnabled(false);
                    }
                } catch (BadLocationException ex) {
                	ex.printStackTrace();
                    //Do something, OK?
                }
            }
            public void insertUpdate(DocumentEvent e) {
                checkDocument(e);
            }
            public void removeUpdate(DocumentEvent e) {
                checkDocument(e);
            }
            public void changedUpdate(DocumentEvent e) {
                checkDocument(e);
            }
        });
        
        
        
        
        
        
        
        frame.setSize(400,200);
        frame.setVisible(true);
    }
}
