package edu.njust.cs.util;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class PicturizedButton extends JButton 
{
	private static final long serialVersionUID = -7782576754032594674L;
	public PicturizedButton(String filename, String text) {
		try {
			PicturizedButton.this.setBorderPainted(false);
			setHorizontalTextPosition(SwingConstants.CENTER);
			setVerticalTextPosition(SwingConstants.BOTTOM);
			setText(text);
			if (filename != null) {
				ImageIcon icon = new ImageIcon(this.getClass().getResource(
						filename));
				if (icon != null)
					setIcon(icon);
			}
		} catch (Exception e) {
			System.out.println("[Error Load Image: " + filename + "]");
			e.printStackTrace();
		}
		this.addMouseListener(new MouseAdapter() {
			public void mouseEntered(MouseEvent e) {
				PicturizedButton.this.setBorderPainted(true);
				PicturizedButton.this.setCursor(Cursor
						.getPredefinedCursor(Cursor.HAND_CURSOR));
			}

			public void mouseExited(MouseEvent e) {
				PicturizedButton.this.setBorderPainted(false);
				PicturizedButton.this.setCursor(Cursor
						.getPredefinedCursor(Cursor.DEFAULT_CURSOR));

			}
		});
	}
}
