package edu.njust.cs.util;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.net.Socket;

import edu.njust.cs.util.IntBytesUtil;

public class SocketChannel 
{

	protected DataInputStream in = null;
	protected DataOutputStream out = null;
	protected Socket socket = null;
	
	protected String IP= null;
	protected int port = 0;
	
	protected boolean connected = false;

	public SocketChannel(String IP_, int port_) 
	{

		IP = IP_;
		port = port_;

	}

	public SocketChannel(Socket s)
	{
		socket = s;
	}
	
	public void connect() throws Exception 
	{
	 	if (socket == null)
    	{
			socket=new Socket(IP,port);
    	}
	 	
	 	socket.setSoTimeout(1000*60);

	 	openInOutStream();
		connected = true;
	}
	
//	public void connect(String ip_, int port_) throws Exception 
//	{
//		IP = ip_;
//		port = port_;
//		connect();
//	}
	
	public void disconnect()
	{
		closeInOutStream();
		
		connected = false;
	}
	
//	public void stopService()
//	{
//		try
//		{
//			if(socket!=null) {
//				socket.close();
//				socket=null;
//			}    	
//		}
//		catch(Exception e)
//		{
//			
//		}
//	}
	public boolean isConnected()
	{
		return connected;
	}

	protected void openInOutStream()  throws Exception
	{
		in = new DataInputStream(socket.getInputStream());
	  	out = new DataOutputStream(socket.getOutputStream());    		
	}

	protected void closeInOutStream() {
		try{
			if(in!=null) {
				in.close();
				in=null;
			}
			if(out!=null) {
				out.close();
				out=null;
			}
			if(socket!=null) {
				socket.close();
				socket=null;
			}    	

		}catch(Exception e){
			e.printStackTrace();
	    }
	}
	

    public byte [] readData(int size)throws Exception
    {
    	byte []dataInByte=new byte[size];
	  	in.readFully(dataInByte);
	  	System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%"+new String(dataInByte));
	  	return dataInByte;	  	
	  	
    }
    

    public void sendData(byte []data) throws Exception
    {
    	out.write(data);
 	  	out.flush();
   }
    
   public int readTextInt(int sizeFieldLen) throws Exception
   {
	  	byte []valInByte=new byte[sizeFieldLen];
	  	int val =0;
	  	in.readFully(valInByte);
	  	String numInStr = new String(valInByte);
	  	
	  	val=Integer.parseInt(numInStr.trim());
	  	return val;
    }
   
   public void sendTextInt(int value, int byteLen) throws Exception
   {
	   String formatStr = "%0" + Integer.toString(byteLen) + "d";		   
	   String toBeSend = String.format(formatStr, value);		   
	   out.write(toBeSend.getBytes());
 	   out.flush();
   }
   public int readBinaryInt()throws Exception
   {
	  	byte []valInByte=new byte[4];
	  	int val=0;
	  	in.readFully(valInByte);
	  	val=IntBytesUtil.byteArrayToInt(valInByte);
	  	return val;
   }
   
   public void sendBinaryInt(int val) throws Exception
   {
       byte []sizeInByte=IntBytesUtil.intToByteArray(val);
	  	out.write(sizeInByte);
	  	out.flush();
   }
   

}