package edu.njust.cs.util;

import java.net.*;
import javax.swing.*;

import java.awt.event.*;
import java.awt.*;

public class TextAndPicButton extends JButton {
	/**
	 * 
	 */
	private static final long serialVersionUID = -7782576754032594674L;

	public TextAndPicButton(String filename, String text) {
		try {
			TextAndPicButton.this.setBorderPainted(false);
			setHorizontalTextPosition(SwingConstants.CENTER);
			setVerticalTextPosition(SwingConstants.BOTTOM);
			setText(text);
			if (filename != null) {
				URLClassLoader urlLoader = (URLClassLoader) this.getClass()
						.getClassLoader();
				URL url = urlLoader.findResource(filename);
				ImageIcon icon = new ImageIcon(url);
				if (icon != null)
					setIcon(icon);
			}
		} catch (Exception e) {
			System.out.println("[load image " + filename
					+ " error in TextAndPicButton]" + e);
		}
		this.addMouseListener(new MouseAdapter() {
			public void mouseEntered(MouseEvent e) {
				TextAndPicButton.this.setBorderPainted(true);
				TextAndPicButton.this.setCursor(Cursor
						.getPredefinedCursor(Cursor.HAND_CURSOR));
			}

			public void mouseExited(MouseEvent e) {
				TextAndPicButton.this.setBorderPainted(false);
				TextAndPicButton.this.setCursor(Cursor
						.getPredefinedCursor(Cursor.DEFAULT_CURSOR));

			}
		});
	}
}
